/******************************************************************************
*
* Atmel Corporation
*
* ̧			: touchscreen_task.c
* ߲		: IAR EWAAVR 4.20A
* 			: $Revision: 0.99 $
* t			: $Date: Thursday, September 20, 2006 $
* XV		: $Author: Jens Rotter $
*
* xҰ		: avr@atmel.com
*
* x޲	: AT90USB1287
*
* pLq		: ?
* 
* 			: ATmega88- ۼު - USB HIDڐGײޗpʉpĳ
*
******************************************************************************/

/******************************************************************************
  ײ
******************************************************************************/

#include "config.h"
#include "conf_usb.h"
#include "touchscreen_task.h"
#include "usb_drv.h"
#include "usb_descriptors.h"
#include "usb_standard_request.h"
#include "wdt_drv.h"

/******************************************************************************
  S̒`
******************************************************************************/

#define Usb_touchscreen_report_reset()	(usb_touchscreen_report[0]=0,usb_touchscreen_report[1]=0,usb_touchscreen_report[2]=0,usb_touchscreen_report[3]=0)

// Z_(1024=őUSBlAHID\핪\Iɒ)
#define XD_1							102
#define XD_2							512
#define XD_3							922

#define YD_1							102
#define YD_2							922
#define YD_3							512

/******************************************************************************
  S̕ϐ
******************************************************************************/

// USB񍐗pz
U8 usb_touchscreen_report[4];
volatile  U8 cpt_sof;
// USBuɂĎgpUSB`Ԑݒ̐i[
extern    U8 usb_configuration_nb;

// 3̍Z_Wpz
struct Touchscreen_Message {
  short int x_pos;
  short int y_pos;
};
volatile struct Touchscreen_Message measurement[4];
// vZꂽZҰ
volatile float CA,CB,CC,CD,CE,CF;

// TWIүޗpɏՕ
unsigned char TWI_messageBuf[6];
// ȂintlASCII(USART̪)ɕϊ邽߂̊ɏՕ
char s[STRING_SIZE];

// دƈړʂ邽߂̌v(ڐGƐڐGIԂ̋Ԃ𑪒)
volatile unsigned char Timer2_ISR_Counter;

/******************************************************************************
  荞
******************************************************************************/
//! @brief TIMER2_OVF_vect
//!
//! دƈړʂ邽߂ɐڐGƐڐGIԂ̋Ԃ𑪒
//!
//!
#pragma vector = TIMER2_OVF_vect
__interrupt void TIMER2_OVF_interrupt(void)
{ // Ԋu:10ms
  TCNT2=178;
  Timer2_ISR_Counter++;

  if(Timer2_ISR_Counter==CLICK_ACCEPT_TIME)
  {
	// /2~
	TCCR2B = (0<<CS20);
  }
}

/******************************************************************************
  ֐
******************************************************************************/
//!
//! @brief ̊֐͐ڐGʍƂɕKvƂʰ޳/ĳ̎
//! B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
//!/
void touchscreen_task_init(void)
{
  // z/ϐؾ
  Usb_touchscreen_report_reset();
  cpt_sof=0;

  // USBǗ(ACK,SOF_ACTION)
  Usb_enable_sof_interrupt();

  // ]upTWIBڽ/܂͈ČĂяő܂
  TWI_Slave_Initialise( (TWI_OWN_SLAVE_ADDRESS<<TWI_ADR_BITS) | (TRUE<<TWI_GEN_BIT) ); 
  // TWI呕u̍ŏ̖߂̎M邽߂TWIMn
  TWI_Start_Transceiver();

  // USART
  USART_Init(MY_UBRR);
}

//! @brief ڐGʊǗ̓_(v敔)
//!
//! ̊֐͐ڐGʂUSB޽q܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void touchscreen_task(void)
{
  if (Is_device_enumerated())
  {
	Usb_select_endpoint(EP_TOUCHSCREEN_IN);
	if (Is_usb_read_control_enabled() && is_twi_received_data_event())
	{ //! ߲ďŋꂽǂ݂ƐVۂ̏Ă邩

	  Usb_write_byte(usb_touchscreen_report[0]);
	  Usb_write_byte(usb_touchscreen_report[1]);
	  Usb_write_byte(usb_touchscreen_report[2]);
	  Usb_write_byte(usb_touchscreen_report[3]);
	  Usb_ack_in_ready();
	}
  }
}

//! @brief is_twi_received_data_event
//!
//! VۂɊւTWI_messageBuf
//!
//! @param	Ȃ
//!
//! @return	EventL(True:False)
bit is_twi_received_data_event(void)
{
  if(cpt_sof<NB_IDLE_POLLING_SOF) 
  {
	return FALSE;
  }
  else
  {
	cpt_sof=0;
	Usb_touchscreen_report_reset();

	// *"AVR311-I2C]uƂĂTWI̎gp"؂*
	// TWIM
	if ( ! TWI_Transceiver_Busy() )
	{
	  // Ō̑삪
	  if ( TWI_statusReg.lastTransOK )
	  {
		// Ō̑삪M
		if ( TWI_statusReg.RxDataInBuf )
		{
		  TWI_Get_Data_From_Transceiver(TWI_messageBuf, 5);

		  // * ߂Ɖ̉ߕ@̗ *
		  if (TestBit(TWI_messageBuf[0],4))
		  {
			// ߏ
			interpret_twi_command();
		  }
		  /*
		  // TWI_CMD_MASTER_READPINBް擾̂߂TWI呕up̑MɏՕɏ܂B
		  if ((TestBit(TWI_messageBuf[0],5)))
		  {
			TWI_messageBuf[0] = PINB;
			TWI_Start_Transceiver_With_Data( TWI_messageBuf, 1 );
		  }
		  */
		}

		// Ō̑삪Mꍇ͂ŏI
		else
		{
		  __no_operation();		// g̺ނɒuĂB
		}

		// TWIMɊJnĂ邩𒲍
		// łȂΐVMɑ΂鏀̂߂ɍĊJ
		if ( ! TWI_Transceiver_Busy() )
		{
		  TWI_Start_Transceiver();
		}
	  }

	  // Ō̑삪Ɋꍇ͂ŏI
	  else
	  {
		TWI_Act_On_Failure_In_Last_Transmission( TWI_Get_State_Info() );
	  }
	}

	return TRUE;
  }
}

//! @brief interpret_twi_command
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void interpret_twi_command(void)
{
  // د=CLICK_ACCEPT_TIME+1X/YW̐ڐGƐڐG̍W
  // ׸ނ1 X/YW̎M܂B
  static unsigned char Coordinates_Received_Flag;
  // z(ZɊւĂ3AȂ0)̈ʒuݒ
  static unsigned char calibrate_counter;

  if(TestBit(TWI_messageBuf[0],7))
  {
	// oؾ -> 3̍Z_W
	calibrate_counter = 3;
	uart_putc('C');
  }
  else if(TestBit(TWI_messageBuf[0],6))
  {
	// x~o
	uart_putc('S');
  }
  else if(TestBit(TWI_messageBuf[0],3))
  {
	// ڐGo -> /2Jn
	Init_Timer2();
	// ׸ ؾ
	Coordinates_Received_Flag = 0;
  }
  else if(TestBit(TWI_messageBuf[0],2))
  {
	// ڐGo
	// د܂͈ړ̕]
	if(TCCR2B!=0)
	{ // v͖ --> CLICK_ACCEPT_TIME
	  // /2~
	  TCCR2B = (0<<CS20);
	  if(Coordinates_Received_Flag==1)
	  { // + WM
		// د=^
		usb_touchscreen_report[0]=1;
	  }
	}

	if(calibrate_counter!=0)
	{ // Z
	  // 1̍Z_W\
	  uart_putc('-');

	  // ̍Z_p̔zʒuݒ
	  calibrate_counter--;

	  if(calibrate_counter==0)
	  { // ZI --> ҰvZ
		Calculate_Calibration_Parameters();
	  }
	}
  }
  else if(TestBit(TWI_messageBuf[0],1))
  {
	// X/YްM
	measurement[calibrate_counter].x_pos=(TWI_messageBuf[1]<<8)|TWI_messageBuf[2];
	measurement[calibrate_counter].y_pos=(TWI_messageBuf[3]<<8)|TWI_messageBuf[4]; 

	if(calibrate_counter==0)
	{ // ZłȂ --> PCɏo
	  // X/YW␳
	  measurement[3].x_pos = (unsigned short int)(CA * measurement[calibrate_counter].x_pos + CB * measurement[calibrate_counter].y_pos + CC);
	  measurement[3].y_pos = (unsigned short int)(CD * measurement[calibrate_counter].x_pos + CE * measurement[calibrate_counter].y_pos + CF);

	  // ZҰ̂߂̌xݒ
	  if(measurement[3].x_pos>1023)
		 measurement[3].x_pos=1023;
	  if(measurement[3].y_pos>1023)
		 measurement[3].y_pos=1023;

	  // USB񍐐ݒ
	  usb_touchscreen_report[1]=(measurement[3].x_pos & 0xFF);
	  usb_touchscreen_report[2]=(measurement[3].x_pos >> 8);
	  usb_touchscreen_report[2]|=(measurement[3].y_pos << 3);
	  usb_touchscreen_report[3]|=(measurement[3].y_pos >> 5);

	  // ׸ސݒ
	  Coordinates_Received_Flag=1;
	}
  }
  else if(TestBit(TWI_messageBuf[0],0))
  {
	// ꌟo
	uart_putc('Q');
  }
}

//! @brief Calculate_Calibration_Parameters
//!
//! ̊֐͐ް^̕\Wɕϊ邽߂6̍ZҰvZ܂B
//! ]3̍Z_Kvł(ʏAؾď̍ŏ3_)B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void Calculate_Calibration_Parameters(void)
{
  signed long CK;

  // Denominator
  CK =  (signed long)(measurement[1].x_pos - measurement[3].x_pos) * (measurement[2].y_pos - measurement[3].y_pos) -
		(signed long)(measurement[2].x_pos - measurement[3].x_pos) * (measurement[1].y_pos - measurement[3].y_pos);

  CA =  ((float)(XD_1 - XD_3) * (measurement[2].y_pos - measurement[3].y_pos) -
		(float)(XD_2 - XD_3) * (measurement[1].y_pos - measurement[3].y_pos)) /
		CK;

  CB =  (CA * (measurement[3].x_pos - measurement[2].x_pos) + XD_2 - XD_3) /
		(measurement[2].y_pos - measurement[3].y_pos);

  CC =  XD_3 - CA * (measurement[3].x_pos) - CB * (measurement[3].y_pos);

  CD =  ((float)(YD_1 - YD_3) * (measurement[2].y_pos - measurement[3].y_pos) -
		(float)(YD_2 - YD_3) * (measurement[1].y_pos - measurement[3].y_pos)) /
		CK;

  CE =  (CD * (measurement[3].x_pos - measurement[2].x_pos) + YD_2 - YD_3) /
		(measurement[2].y_pos - measurement[3].y_pos);

  CF =  YD_3 - CD * (measurement[3].x_pos) - CE * (measurement[3].y_pos);
}

//! @brief Init_Timer2
//!
//! ̊֐/2ꓮ`Ԃŏ܂Bدƈړʂ邽߂
//! ڐGƐڐG̍Ō̊Ԃ̊Ԃ𑪒肵܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void Init_Timer2(void)
{ // /2(ꓮ`)
  TCNT2=178;
  TIMSK2 = (1<<TOIE2);
  TCCR2B = (7<<CS20);
  Timer2_ISR_Counter=0;
}

//! @brief sof_action
//!
//! ̊֐USBڰъJn(SOF)荞ݻٰ݂s(1ms)cpt_sof
//! v𑝂܂B͎ԒxǗɗLpłB
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void sof_action()
{
  cpt_sof++;
}

//! @brief vbus_off_action
//!
//! ̊֐USB VBUSؒfŎsׂs܂B
//! ͐ؒf̂߂Vbus𓱂܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void vbus_off_action(void)
{
  Usb_detach();
}
