/****************************************************************************
*
* Atmel Corporation
*
* ̧			: Touchscreen.c
* ߲		: IAR EWAAVR 4.20A
* 			: $Revision: 0.99 $
* t			: $Date: Thursday, September 20, 2006 $
* XV		: $Author: Jens Rotter $
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega88
*
* pLq		: ?
*
* 			: ڐGʐ 4(Low/Rtouch)5(Lowّ)
*
****************************************************************************/

/****************************************************************************
  ײ
****************************************************************************/

#include "Touchscreen.h"

/****************************************************************************
  S̕ϐ
****************************************************************************/

Interface Touchscreen_Data;										// ̪ϐ

volatile unsigned int Counter_Sleep;							// x~׸ސݒ̂߂̌v
static unsigned char Counter_Untouch_Condition;					// I׸ސݒ̂߂̌v

volatile unsigned char ADC_ISR_Switch=1;						// Ǘ

static short int Readings_X_Pos[SAMPLES_FOR_ONE_TRUE_XY_PAIR];	// X/YWpz
static short int Readings_Y_Pos[SAMPLES_FOR_ONE_TRUE_XY_PAIR];
static unsigned char i_array;

/****************************************************************************
  荞
****************************************************************************/

#pragma vector = PIN_CHANGE_VECTOR
__interrupt void Pin_Change_ISR(void)
{
  // x~֎~
//  SMCR = (0 << SE);

  ClearBit(PIN_CHANGE_INTERRUPT_CONTROL_REGISTER, PIN_CHANGE_INTERRUPT_ENABLE_1);	// ݕω荞݋֎~
  TIMER0_CONTROL_REGISTER_B = (TIMER0_PRESCALER << TIMER0_CLOCK_SELECT);			// vۯJn(CTC)
  Counter_Sleep = 0;																// x~vؾ(˒)
}

#pragma vector = TIMER0_COMPARE_MATCH_A_VECTOR 
__interrupt void Timer0_Compare_Match_A_ISR(void)
{
  static unsigned char Counter_Debounce=0;

  if(TestBit(ADC_CONTROL_AND_STATUS_REGISTER_A, ADC_ENABLE))
  { // isŁTimer0_Compare_Match_A_ISRA/DϊN
	START_CONVERSION;				// A/DϊJn
  }
  else
  {
	if(!TestBit(PIN_CHANGE_INTERRUPT_CONTROL_REGISTER, PIN_CHANGE_INTERRUPT_ENABLE_1))
	{ // ݕω荞݂ꂽł˒

	  if(TestBit(TOUCHSCREEN_INPUT, STANDBY_PIN))
	  { // Y-HighقCounter_Debounceؾ
		Counter_Debounce = 0;
	  }
	  else
	  { // Y-LowقCounter_Debounce
		Counter_Debounce++;
	  }
	  if(Counter_Debounce == DEBOUNCE_TIME)
	  {
		Counter_Debounce = 0;		// Counter_Debounceؾ
		Start_Measurement();
	  }
	}
	Counter_Sleep++;				// Counter_Sleep
	if(Counter_Sleep == SLEEP_COUNTDOWN)
	{ // x~B
	  Counter_Debounce = 0;			// Counter_Debounceؾ
	  TIMER0_CONTROL_REGISTER_B = (0 << TIMER0_CLOCK_SELECT);		// vۯ~(CTC)
	  Stop_Measurement();
	  SetBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_SLEEP);	// ̪:VYˋx~
	}
  }
}

#pragma vector = TIMER0_COMPARE_MATCH_B_VECTOR 
__interrupt void Timer0_Compare_Match_B_ISR(void)
{
  if (TestBit(ADC_ISR_Switch,0))	// JnOI/O𒼐ڐݒ
  {
	STANDBY_CONFIGURATION;			// I/O:ڐGp
  }
  else if (TestBit(ADC_ISR_Switch,1))
  {
	X_POS_CONFIGURATION;			// I/O:XW\ݒ
  }
  else if (TestBit(ADC_ISR_Switch,2))
  {
	Y_POS_CONFIGURATION;			// I/O:YW\ݒ
  }
#if defined R_TOUCH_MEASUREMENT
  else if (TestBit(ADC_ISR_Switch,3))
  {
	Z_1_AND_2_CONFIGURATION;		// I/O:Z1W\ݒ
  }
  else if (TestBit(ADC_ISR_Switch,4))
  {
	Z_1_AND_2_CONFIGURATION;		// I/O:Z2W\ݒ
  }
#endif
}

#pragma vector = ADC_CONVERSION_COMPLETE_VECTOR
__interrupt void ADC_Conversion_Complete_ISR(void)
{
  ADC_Measurement();
}

/****************************************************************************
  ֐錾
****************************************************************************/
void Touchscreen_Init(void)
{
  STANDBY_CONFIGURATION;				// I/O:ڐGp

  // ݕω
  SetBit(PIN_CHANGE_MASK_1_REGISTER, PIN_CHANGE_ENABLE_MASK);					// ݕω荞݌ݒ
  SetBit(PIN_CHANGE_INTERRUPT_CONTROL_REGISTER, PIN_CHANGE_INTERRUPT_ENABLE_1);	// ݕω荞݋

  // /0(CTC)
  TIMER0_CONTROL_REGISTER_A = (2 << TIMER0_WAVEFORM_GENERATION_MODE);			// rvA/ݒ
  TIMER0_OUTPUT_COMPARE_REGISTER_A = TIMER0_INITIAL_VALUE_COMPARE_MATCH_A;		// rAڼ޽`lɐݒ
  TIMER0_OUTPUT_COMPARE_REGISTER_B = TIMER0_INITIAL_VALUE_COMPARE_MATCH_B;		// rBڼ޽`lɐݒ
  TIMER0_INTERRUPT_MASK_REGISTER = (1 << TIMER0_OUTPUT_COMPARE_A_INT_ENABLE);	// /0rAv荞݋
  TIMER0_CONTROL_REGISTER_B = (TIMER0_PRESCALER << TIMER0_CLOCK_SELECT);		// vۯJn(CTC)

  SetBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_START);					// ̪:Vہˏؾ
}

void Start_Measurement(void)
{
  Counter_Sleep = 0			// x~vؾ

  SetBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_TOUCH);							// ̪:VہːڐGo

  // A/Dϊ평(ݸ )
  ADC_CONTROL_AND_STATUS_REGISTER_A  = (1 << ADC_ENABLE) | (1 << ADC_INTERRUPT_ENABLE) | (ADC_PRESCALER << ADC_PRESCALER_SELECT);	// ,荞݋,Ouݒ
  ADC_MULTIPLEXER_SELECTION_REGISTER = STANDBY_PIN | (1 << ADC_REFERENCE_SELECTION);	// ڐGpA/Dϊِݒ

  SetBit(TIMER0_INTERRUPT_FLAG_REGISTER, TIMER0_OUTPUT_COMPARE_B_MATCH_FLAG);			// /0rBv荞ݗv׸މ
  SetBit(TIMER0_INTERRUPT_MASK_REGISTER, TIMER0_OUTPUT_COMPARE_B_INT_ENABLE);			// /0rBv荞݋
}

void Stop_Measurement(void)
{
  // ϐؾ
  Counter_Untouch_Condition = 0;
  i_array = 0;
  ADC_ISR_Switch=1;

  STANDBY_CONFIGURATION;			// I/O:ڐGp

  ADC_CONTROL_AND_STATUS_REGISTER_A = (0 << ADC_ENABLE);							// A/Dϊ֎~

  ClearBit(TIMER0_INTERRUPT_MASK_REGISTER, TIMER0_OUTPUT_COMPARE_B_INT_ENABLE);		// /0rBv荞݋֎~

  SetBit(PIN_CHANGE_INTERRUPT_FLAG_REGISTER, PIN_CHANGE_INTERRUPT_FLAG_1);			// ݕω荞ݗv׸މ
  SetBit(PIN_CHANGE_INTERRUPT_CONTROL_REGISTER, PIN_CHANGE_INTERRUPT_ENABLE_1);		// ݕω荞݋
}

void Insertion_Sort(short int Array[])
{
  signed char i;
  unsigned char j;
  short int current;

  // Array[]z񏇗
  for(j=1; j<SAMPLES_FOR_ONE_TRUE_XY_PAIR; j++)
  {
	current = Array[j];
	i = j - 1;
	while(i>=0 && Array[i]>current)
	{
	  Array[i+1] = Array[i];
	  i--;
	}
	Array[i+1] = current;
  }
}

void Store_valid_Data(void)
{
  // zɗLްi[
  if(i_array==(END_OF_ARRAY))
  { // zǗ

	// l𓾂邽߂X/Yǂݎl
	Insertion_Sort(Readings_X_Pos);
	Insertion_Sort(Readings_Y_Pos);

	Check_Overflow(FLAG_REGISTER_COORDINATES);							// ̪:Wǂݍ݂ȂΌAȂΈ׸ސݒ

	// ̪: p\ȐVW쐬
	Touchscreen_Data.x_pos = Readings_X_Pos[MEDIAN];
	Touchscreen_Data.y_pos = Readings_Y_Pos[MEDIAN];

	SetBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_COORDINATES);	// ̪:VہːVW

	i_array=0;						// i_arrayؾ
  }
  else
  {
	i_array++;						// i_array
  }
  Counter_Untouch_Condition = 0;	// Counter_Untouch_Conditionؾ
}

#if defined LOW_LEVEL_MEASUREMENT
void ADC_Measurement(void)
{
  static short int Reading_Low_Level;

  HI_Z_CONFIGURATION;				// ڐGʗpd~

  if (TestBit(ADC_ISR_Switch,0))
  {
	Reading_Low_Level = ADC;		// p:Reading_Low_Levelpl

	if(Reading_Low_Level < MAXIMUM_LOW_LEVEL)
	{ // Reading_Low_Level=TRUE

	  if(TestBit(ADC_ISR_Switch,7))
	  { // ADC_ISR_Switch,ޯ7=p\ŗLX/YWp׸
		Store_valid_Data();
	  }
	  ClearBit(ADC_ISR_Switch,0);	// ADC_ISR_SwitchݒAReading_Low_Levelؾ
	  SetBit(ADC_ISR_Switch,1);		// :XW(Timer0_Compare_Match_B_ISRI/O\ݒ)
	  SetBit(ADC_ISR_Switch,7);		// Reading_Low_Levelp׸=TRUE
	}
	else
	{ // Reading_Low_Level=FALSE
	  Counter_Untouch_Condition++;	// Counter_Untouch_Condition
	  if(Counter_Untouch_Condition == MAXIMUM_UNTOUCH_CONDITIONS)
	  { // I
		Stop_Measurement();
		SetBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_END);	// ̪:VہːڐGoI
	  }
	  // ADC_ISR_Switchݒ(:Reading_Low_Level)
	  ClearBit(ADC_ISR_Switch,7);	// ؾ"LX/YWp"
	}
  }
  else if (TestBit(ADC_ISR_Switch,1))
  {
	Readings_X_Pos[i_array] = ADC;	// p:XWpl
	ADC_MULTIPLEXER_SELECTION_REGISTER = ADC1 | (1 << ADC_REFERENCE_SELECTION);	// YWpA/Dϊِݒ
	ClearBit(ADC_ISR_Switch,1);		// ADC_ISR_SwitchݒAXWؾ
	SetBit(ADC_ISR_Switch,2);		// :YW(Timer0_Compare_Match_B_ISRI/Oݒ)
  }
  else if (TestBit(ADC_ISR_Switch,2))
  {
	Readings_Y_Pos[i_array] = ADC;	// p:YWpl
	ADC_MULTIPLEXER_SELECTION_REGISTER = STANDBY_PIN | (1 << ADC_REFERENCE_SELECTION);	// ڐGpA/Dϊِݒ

	ClearBit(ADC_ISR_Switch,2);		// ADC_ISR_SwitchݒAYWؾ
	SetBit(ADC_ISR_Switch,0);		// :Reading_Low_Level(Timer0_Compare_Match_B_ISRI/Oݒ)
  }
}
#endif

#if defined R_TOUCH_MEASUREMENT
void ADC_Measurement(void)
{
  static short int      Reading_Low_Level;
  static short int      Reading_Z1;
  static short int      Reading_Z2;
  static long int       R_Touch;

  HI_Z_CONFIGURATION;				// ڐGʗpd~

  if (TestBit(ADC_ISR_Switch,0)) 
  {
	Reading_Low_Level = ADC;		// p:Reading_Low_Levelpl

	if(Reading_Low_Level < MAXIMUM_LOW_LEVEL)
	{ // Reading_Low_Level = TRUE

	  ClearBit(ADC_ISR_Switch,0);	// ADC_ISR_SwitchݒAReading_Low_Levelؾ
	  SetBit(ADC_ISR_Switch,1);		// :XW(Timer0_Compare_Match_B_ISRI/O\ݒ)
	}
	else
	{ // Reading_Low_Level = FALSE
	  Counter_Untouch_Condition++;	// Counter_Untouch_Condition
	  if(Counter_Untouch_Condition == MAXIMUM_UNTOUCH_CONDITIONS)
	  { // I
		Stop_Measurement();
		SetBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_END);	// ̪:VہːڐGoI
	  }
	  SetBit(ADC_ISR_Switch,0);		// ADC_ISR_Switchݒ(:Reading_Low_Level)
	}
  }
  else if (TestBit(ADC_ISR_Switch,1))
  {
	Readings_X_Pos[i_array] = ADC;	// p:XWpl
	ADC_MULTIPLEXER_SELECTION_REGISTER = ADC1 | (1 << ADC_REFERENCE_SELECTION);	// YWpA/Dϊِݒ
	ClearBit(ADC_ISR_Switch,1);		// ADC_ISR_SwitchݒAXWؾ
	SetBit(ADC_ISR_Switch,2);		// :YW(Timer0_Compare_Match_B_ISRI/Oݒ)
  }
  else if (TestBit(ADC_ISR_Switch,2))
  {
	Readings_Y_Pos[i_array] = ADC;	// p:YWpl
	ClearBit(ADC_ISR_Switch,2);		// ADC_ISR_SwitchݒAYWؾ
	SetBit(ADC_ISR_Switch,3);		// :Z1(Timer0_Compare_Match_B_ISRI/Oݒ)
  }
  else if (TestBit(ADC_ISR_Switch,3))
  {
	Reading_Z1 = ADC;				// p:Z1Wpl
	ADC_MULTIPLEXER_SELECTION_REGISTER = ADC2 | (1 << ADC_REFERENCE_SELECTION);	// Z2pA/Dϊِݒ
	ClearBit(ADC_ISR_Switch,3);		// ADC_ISR_SwitchݒAZ1ؾ
	SetBit(ADC_ISR_Switch,4);		// :Z2(Timer0_Compare_Match_B_ISRI/Oݒ)
  }
  else if (TestBit(ADC_ISR_Switch,4))
  {
	Reading_Z2 = ADC;				// p:Z2Wpl
	R_Touch = ((float)Reading_Z2/Reading_Z1-1) * Readings_X_Pos[i_array];		// R_TouchςvZ
	if(R_Touch<=MAXIMUM_RTOUCH_LEVEL)
	{
	  Store_valid_Data();			// zɗLްi[
	}
	ADC_MULTIPLEXER_SELECTION_REGISTER = STANDBY_PIN | (1 << ADC_REFERENCE_SELECTION);	// ڐGpA/Dϊِݒ
	ClearBit(ADC_ISR_Switch,4);		// ADC_ISR_SwitchݒAZ2ؾ
	SetBit(ADC_ISR_Switch,0);		// :Reading_Low_Level(Timer0_Compare_Match_B_ISRI/Oݒ)
  }
}
#endif
